#!/usr/bin/perl

###################################################################################################
## Ho eliminato il TAINT mode perche' mi impediva di eseguire il comando FIND con l'opzione MMIN ##
###################################################################################################

use strict;
$ENV{'PATH'}="";

#############################################################################################################
## Se si desidera CREARE un nuovo file MD5, inviare la query string cmd=create
## Se si desidera verificare le checksum, inviare la query string cmd=verify
## Il file $md5file sara' SEMPRE non verificato!!! Questo perche' quando creo il file, quel file non esiste!!
## Nel momento in cui si trova una anomalia, se l'anomalia e' giustificata, ricreare un nuovo file MD5
## Per sicurezza, salvare una copia del file MD5 altrove
## Attenzione ai percorsi assoluti dei comandi Linux, all'interno delle chiamate system:

my $stat = "/usr/bin/stat";
my $data = "/bin/date";
my $find = "/usr/bin/find";
my $xargs = "/usr/bin/xargs";
my $md5sum = "/usr/bin/md5sum"; 
#############################################################################################################

print "Content-type:text/plain\n\n";

my $base='/My/home/';
my $data_location = $base."mysecure/";
my $MyPathErr = $data_location."myerror";
my $md5file = $data_location."result.md5";
my $today = localtime(time);
my %GET;

#####################################################
#### Inizializzazione dell'eventuale QueryString ####
#####################################################

my @gets;

if (exists $ENV{"QUERY_STRING"} && $ENV{"QUERY_STRING"})             {

        if ($ENV{"QUERY_STRING"} =~ /&/)                {

                (@gets) = split (/&/, $ENV{"QUERY_STRING"});

                }

        else    {

                push(@gets, $ENV{"QUERY_STRING"});

                }

        }

foreach my $query(@gets)        {

        my ($key,$value) = split(/=/, $query);
        $GET{$key} = $value;

        }

#############################################################################
#########################                           #########################
######################### Versione 13 marzo 2013    #########################
#########################                           #########################
#############################################################################

*MYERR=*STDERR;
open(MYERR, ">>$MyPathErr");

print "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n";
print "Test in esecuzione in data: $today ";
print "- Inizio Test\n";
print "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n\n";

if($GET{'cmd'} && $GET{'cmd'} eq "create")
	{

	if(-e $md5file) { unlink $md5file; }

	print "\n\n+++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n";
	print "Ora creo la lista delle checksum\n";
	print "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n\n";

	eval { system($find." ".$base." -type f -print0 | ".$xargs." -n 1 -0 ".$md5sum." 1>$md5file" ); };
	print $@ if($@);

	}

elsif($GET{'cmd'} && $GET{'cmd'} eq "verify")
	{

	#######################################################
	## Data ( in EPOCH ) di ultima modifica del file MD5 ##
	my $ref=`$stat --format=%Y $md5file`;
	my $refreal=`$stat --format=%y $md5file`;

	###############################
	## Data attuale ( in EPOCH ) ##
	my $today=`$data +%s`;

	#################################################################
	## Numero di minuti trascorsi dall'ultima modifica al file MD5 ##
	my $diff = sprintf("%.0f", ($today-$ref)/60);

	print "Data di creazione del file MD5: ", $refreal;
	print "Minuti intercorsi dall'ultima modifica al file MD5: ", $diff, "\n";
	print "File creati e/o modificati in questi $diff minuti:\n\n";

	system("$find $base -type f -mmin -$diff -print0 | $xargs -r -n 1 -0 $stat --format='%n %y'");

	print "\n\n+++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n";
	print "Ora verifico la lista delle checksum\n";
	print "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n\n";
	
	eval { system("$md5sum -c $md5file -w 2>&1"); };
	print $@ if($@);

	}

print "\n\n+++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n";
print "Checksum MD5 attuale per il file MD5\n";
print "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n\n";

system("$md5sum $md5file");

print "\n\n+++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n";
print "Fine Test\n";
print "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n\n";

close MYERR;
exit;
